

#pragma option(pedantic,on)
#region Imports
#include 'slick.sh'
#include 'tagsdb.sh'
#import "adaptiveformatting.e"
#import "alias.e"
#import "autocomplete.e"
#import "c.e"
#import "cutil.e"
#import "listproc.e"
#import "main.e"
#import "notifications.e"
#import "slickc.e"
#import "stdcmds.e"
#import "stdprocs.e"
#import "surround.e"
#import "tagform.e"
#import "tags.e"
#import "vc.e"
#import "se/lang/api/LanguageSettings.e"
#endregion

using se.lang.api.LanguageSettings;

#define MODE_NAME  "ALA"
#define LEXER_NAME "ALA"
#define LANG_ID "ALA"
#define LANG_EXTENSION "ala"

void debug_log(_str a_line )
{
   //_str command = "echo " :+ a_line :+ " >> " :+ "g:/TestingSlick/logdir/log.txt";
   //shell( command , "Q"); // Q- do not show console window
   //message(command);
  _SccDisplayOutput(a_line);
}

/*
int _CreateLanguage(_str langId,          _str mode_name='',
                    _str setup_info='',   _str compile_info='',
                    _str syntax_info='',  _str be_info='',    
                    _str include_info='', _str word_chars='',
                    _str lexer_name='',   _str color_flags='')
*/

defload()
{
    _str setup_info = "MN="MODE_NAME",":+   // mode name
                      "TABS=+3,":+               // tab settings
                      "MA=1 74 1,":+             // margins for word wrap
                      "KEYTAB=ext-keys,":+       // key table (generic language keys)
                      "WW=0,":+                  // word wrap off by default 
                      "IWT=0,":+                 // indent with tabs (off)
                      "ST=0,":+                  // show tabs (off)
                      "IN=2,":+                  // indent style = syntax indent
                      "WC=A-Za-z0-9_$,":+        // word characters
                      "LN="LEXER_NAME",":+   // color coding lexer name
                      "CF=1";                    // color flags
    _str compile_info="";
    _str syntax_info="3 1 2 1 0 1 0";
    _str be_info="";

    _CreateLanguage(LANG_ID,
                    MODE_NAME,
                    setup_info,
                    compile_info,
                    syntax_info,
                    be_info,
                    "",// include_info
                    "", // word_chars
                    LEXER_NAME, // lexer name
                    ""); // color flags 

    _CreateExtension(LANG_EXTENSION, LANG_ID);

    _str file_vlx = _ConfigPath() :+ FILESEP :+ LANG_EXTENSION :+ ".vlx";
    if (file_exists(file_vlx))
    {
        _str cload_status = cload(file_vlx);
        _SccDisplayOutput("File '"file_vlx"' loading status ='"cload_status"'");
    }
    else
    {
      _SccDisplayOutput("Error: file '"file_vlx"' does not exist.");
    }

    _SccDisplayOutput("Lexer name for lang id '"MODE_NAME"' is :'"_LangId2LexerName(LANG_ID)"'");

}


int _ala_MaybeBuildTagFile(int &tfindex)
{
   _str langid = LANG_ID;
   _str tagfilename = '';
   if (ext_MaybeRecycleTagFile(tfindex, tagfilename, LANG_EXTENSION, LANG_ID)) {
      return(0);
   }
/**
 * Generic function for building tag file when the only thing
 * to tag is one builtin's function.
 *
 * @param tfindex      (reference) index of def_tagfiles_[ext]
 * @param ext          file extension
 * @param basename     base name of extension specific tagfile
 * @param description  tag file description
 *
 * @return 0 on success, <0 on error.
 */
   int status = ext_MaybeBuildTagFile(tfindex, LANG_EXTENSION, LANG_EXTENSION, "ALA Builtins"); // no 'ala' builtins for now
   return 0;
}

/*

#pragma option(strict,on)
#include "slick.sh"

*/


#define REGEX_PATTERN_1 '[ \t]*{function}[ \t]*{[a-zA-Z0-9_$]#} *'
int ala_proc_search(_str &proc_name, int find_first)
{
    //debug_log( "1.procname '" :+ proc_name :+ "'");

    typeless status=0;
    //debug_log( "2.findfirst '" :+ find_first :+ "'");
    if ( find_first )
    {
        status=search('(function)','@rihwxsc');
        //debug_log( "2.1 search status '" :+ status :+ "'");
    }
    else
    { 
        //debug_log( "2.1 repeating search...");
        status=repeat_search();
        //debug_log( "2.2 search status '" :+ status :+ "'");
    }

    _str line='';
    _str symbol_name='';
    _str ala_symbol_type='';
    for (;;)
    {
        if ( status )
        {
            return(status);
        }
        get_line(line);
        //debug_log( "3.line '" :+ line :+ "'");

        if ( pos(REGEX_PATTERN_1,line,0,'R') )
        {
            ala_symbol_type = substr(line,pos('S0'),pos("0"));
            symbol_name = substr(line,pos('S1'),pos("1"));

            // hardcoding finded symbol as 'function'
            
            _str vs_type_name;
            tag_get_type(VS_TAGTYPE_function, vs_type_name);
            /*
extern _str tag_tree_compose_tag( _str tag_name, 
                                  _str class_name, 
                                  _str type_name,
                                  int tag_flags=0, 
                                  _str arguments="", 
                                  _str return_type="", ...);
*/

            symbol_name=tag_tree_compose_tag(symbol_name,
                                             '',
                                             vs_type_name,
                                             0,
                                             '',
                                             '');
            //debug_log( "4. combined symbol name '" :+ symbol_name :+ "'");
            if ( proc_name=='' )
            {
                proc_name=symbol_name;
            }
            else if ( proc_name :== symbol_name )
            {
                //debug_log( "5. callning repeat search");
                status=repeat_search();
                continue;
            }
            //debug_log( "5.1. return 0");
            return(0);
        }
        else
        {
            //debug_log( "6. callning repeat search");
            status=repeat_search();
        }
    }
    //debug_log( "6.1. return");
}


